package com.chang.sms;

import java.io.*;
import java.util.*;
import java.util.List;

public class Agenda 
{
  List contactos = new ArrayList();
  
  public Agenda()
  {
  }

  public void initAgenda() throws Exception
  {
    String home = System.getProperty("user.home", "not specified");    
    File linuxSMSDirectory = new File(home,".linuxsms");
    File agenda = new File(linuxSMSDirectory,"addressbook");
    BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(agenda)));
    String linea = reader.readLine();
    while (linea!=null)
    {
      if (!linea.startsWith("#"))
      {
        StringTokenizer st = new StringTokenizer(linea,":");
        int i = 0;
        String[] campo = new String[3];
        // En el bucle solo tenemos en cuenta:
        // 0 --> Nombre
        // 1 --> Prefijo
        // 2 --> Nmero
        while (st.hasMoreTokens() && i<3)
          campo[i++] = st.nextToken();

        if (campo[0]!=null && campo[1]!=null && campo[2]!=null)
        {
          if (campo[1] == null || campo[1].equals(""))
            campo[1] = "34";
          contactos.add(campo);
        }
      }
      linea = reader.readLine();
    }
  }

  public List getContactos()
  {
    return contactos;
  }

  public void addContacto(String[] contacto)
  {
    contactos.add(contacto);
  }

  public void removeContacto(String[] contacto)
  {
    Iterator iterar = contactos.iterator();
    boolean encontrado = false;
    int pos = 0;
    while (iterar.hasNext() && !encontrado)
    {
      String[] aux = (String[])iterar.next();
      if (aux[0].equals(contacto[0]) && aux[1].equals(contacto[1]) && aux[2].equals(contacto[2]))
      {
        contactos.remove(pos);
        encontrado = true;
      }
      pos++;
    }
  }

  public void updateContacto(String[] contacto)
  {
    Iterator iterar = contactos.iterator();
    boolean encontrado = false;
    int pos = 0;
    while (iterar.hasNext() && !encontrado)
    {
      String[] aux = (String[])iterar.next();
      if (aux[0].equals(contacto[0]) && aux[1].equals(contacto[1]) && aux[2].equals(contacto[2]))
      {
        contactos.set(pos,contacto);
        encontrado = true;
      }
      pos++;
    }
  }

  public void saveAgenda() 
  {
    try{
      String home = System.getProperty("user.home", "not specified");    
      File linuxSMSDirectory = new File(home,".linuxsms");
      File agenda = new File(linuxSMSDirectory,"addressbook");
      PrintWriter writer = new PrintWriter(new OutputStreamWriter(new FileOutputStream(agenda)));
      Iterator iterar = contactos.iterator();

      writer.println("#");
      writer.println("# ADDRESSBOOK");
      writer.println("# format is: name:prefix:number:default_server");
      writer.println("# ...and YES, CASE IS SENSITIVE!");
      writer.println("# lines starting with # or blank lines are ignored");
      writer.println("# there must be a BLANK line at end (the end)");
      writer.println("#");
      while (iterar.hasNext())
      {
        String[] aux = (String[])iterar.next();
        String linea = aux[0]+":"+aux[1]+":"+aux[2]+":default_server";
        writer.println(linea);
      }    
      writer.println("#");
      writer.close();
    }catch (Exception e)
    {
      System.out.println("Error"+e);
    }
  }
}