package com.chang.sms;
import java.util.*;
import java.io.*;

public class Idioma
{
  private String language="es";
  private String country="ES";
  private String home = System.getProperty("user.home", "not specified");

  public Idioma()
  {
    try{
      Properties props = getProperties("init.properties");
      language = props.getProperty("language");
      country = props.getProperty("country");
    }catch(Exception ee)
    {
      System.out.println("Error:"+ee);
    }
  }
  
  public Idioma(String language,String country)
  {
    this.language = language;
    this.country = country;
  }

  private Properties getPropertiesLocale(String archivo) throws Exception
  {
    Properties props = new Properties();
    File file = new File(home,".linuxsms");
    file = new File(file,"idioma");
    file = new File(file,archivo+"_"+language+"_"+country+"."+"properties");
    props.load(new FileInputStream(file));
    return props;
  }

  private Properties getProperties(String archivo) throws Exception
  {
    Properties props = new Properties();        
    File file = new File(home,".linuxsms");
    file = new File(file,"idioma");
    file = new File(file,archivo);
    props.load(new FileInputStream(file));
    return props;
  }

  private String getPath(String fichero)
  {
    File file = new File(home,".linuxsms");
    file = new File(file,"idioma");
    file = new File(file,fichero);    
    return file.getAbsolutePath();
  }
  
  public String getTexto(String codigo)
  {
    String salida = "";
    try{
      Properties props = getPropertiesLocale("idiomas");    
      salida = props.getProperty(codigo);      
    }catch (Exception ee)
    {
      System.out.println("Error:"+ee);
    }
    return salida;
  }

  public List getIdiomas() throws Exception
  {
    List salida = new ArrayList();
    String path= getPath("configuracion.txt");
    BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(path),"ISO_8859-15"));
    String linea = reader.readLine();
    while (linea!=null)
    {
      String aux[] = new String[3];
      StringTokenizer st = new StringTokenizer(linea);
      for (int i=0;i<3;i++)
        aux[i] = st.nextToken();
      salida.add(aux);
      linea = reader.readLine();
    }
    return salida;
  }

  public void updateInit() throws Exception
  {
    Properties props = getProperties("init.properties");
    props.setProperty("country",country);
    props.setProperty("language",language);
    props.store(new FileOutputStream(getPath("init.properties")),"Configuracin");
  }
  
  public void setCountry(String newCountry)
  {
    country = newCountry;
  }

  public void setLanguage(String newLanguage)
  {
    language = newLanguage;
  }
}