package com.chang.sms;

import java.awt.*;
import java.awt.event.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.*;

import java.util.*;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.event.*;
import javax.swing.text.*;

public class linuxSMS extends JFrame implements ActionListener
{
  private JMenuItem menuHelpAbout = new JMenuItem();
  private JMenu menuHelp = new JMenu();
  private JMenu menuIdiomas = new JMenu();
  private JMenuItem menuFileExit = new JMenuItem();
  private JMenu menuFile = new JMenu();
  private JMenu menuServer = new JMenu();
  private JMenuBar menuBar;
  private JPanel panelCenter = new JPanel();
  private BorderLayout layoutMain = new BorderLayout();
  private JTextField contacto = new JTextField(10);
  private JTextField numero = new JTextField(10);
  private JTextField maxChars = new JTextField(3);
  private JTextField numerotoSend = new JTextField(13);
  private JTextField prefijo = new JTextField(3);
  private JTable table = new JTable(new modeloAgenda());
  private JLabel servidor = new JLabel("");
  private LimitedStyledDocument lsd = new LimitedStyledDocument(500);
  private JTextPane mensaje = new JTextPane(lsd);  
  private JTextPane debug = new JTextPane();
  private modeloAgenda modelo = (modeloAgenda)table.getModel();  
  private int filaAgenda = 0,MAX=0,CHARSFORWRITE=0;
  private int columna,fila;
  private Component cmp;
  private skinSMS skin;
  private Idioma idioma;
  private java.util.List idiomas;
  private java.util.List servidores;
  private String language="es";
  private String country="ES";
  private Servers servers = new Servers();
  private Agenda agenda = new Agenda();
  
  public linuxSMS()
  {
    try {init();}
    catch(Exception e){e.printStackTrace();}
  }

  private void init() throws Exception
  {
      skin = new skinSMS();
      idioma = new Idioma();      
      jbInit();
      initAgenda();
      initServers();    
  }
  
  private void initServers() throws Exception 
  {
    // Inicializamos el arrays de servidores    
    java.util.List lista = servers.initServers();   
    servidores = servers.getServidores();

    // Obtenemos el archivo con los servidores
    Iterator iterar = lista.iterator();
    while (iterar.hasNext())
    {
      String linea = (String)iterar.next();
      if (!linea.equals(""))
      {
        // Creamos el nuevo item del men de servidores
        JMenuItem aux = new JMenuItem(linea);
        aux.setOpaque(setComponentOpaque(skin.MENU));
        aux.setForeground(setComponentColor(skin.MENU));
        aux.setFont(setComponentFont(skin.MENU));
        aux.setBackground(setComponentBGColor(skin.MENU)); 
        aux.addActionListener(this);
        menuServer.add(aux);

      }
    }
  }

  
  // Evento que controla la longitud de los mensajes
  public void actionPerformed(ActionEvent e) {
    try{
        StringTokenizer st = new StringTokenizer(e.getActionCommand(),"#");
        if (st.hasMoreTokens())
        {
          String aux = st.nextToken();
          servidor.setText(idioma.getTexto("SERVER")+ ":"+aux);
          String max = servers.findServerMaxChars(aux);
          MAX = Integer.parseInt(max);
          maxChars.setText(max);
          String mensaje_old = mensaje.getText();
          if (mensaje_old.length()>MAX)
            mensaje_old = mensaje.getText(0,MAX);
          CHARSFORWRITE = MAX - mensaje_old.length();
          mensaje.setStyledDocument(new LimitedStyledDocument(Integer.parseInt(max)));
          mensaje.setText(mensaje_old);
          mensaje.getDocument().addDocumentListener(new DocumentListener()
          {
              public void removeUpdate(DocumentEvent e)
              {         
                maxChars.setText(++CHARSFORWRITE+"");
              }
              public void insertUpdate(DocumentEvent e)
              {
                maxChars.setText(--CHARSFORWRITE+"");
              }
              public void changedUpdate(DocumentEvent e)
              {           
              }
          }
          );
        }
    }catch(Exception er) {System.out.println("Error"+er);}
  }

  
  // Inicializa la agenda
  private void initAgenda() throws Exception
  {
    agenda.initAgenda();
    Iterator iterar = agenda.contactos.iterator();
    while (iterar.hasNext())
      modelo.addValue((String[])iterar.next());        
  }
  
  private void jbInit() throws Exception
  {          
    // Inicializamos los paneles
    initMenus();
    initMainFrame();
    initPanelCenter();
    initIcons();
    panelSMS();
    panelAgenda();
    panelAgendaContactos();
    panelAgendaAcciones();    
    panelDebug();
    getContentPane().add(panelCenter);
  }

  // Monta el panel de debug
  private void panelDebug() throws Exception
  {
    debug.setForeground(setComponentColor(skin.DEBUG));
    debug.setBounds(setComponentBounds(skin.DEBUG));
    debug.setOpaque(setComponentOpaque(skin.DEBUG));
    debug.setCaretPosition(0);
    debug.setMargin(new Insets(2,2,2,2));    
    debug.setPreferredSize(setComponentDimension(skin.DEBUG));
    debug.setAutoscrolls(true);    
    debug.setEditable(false);
    
    JScrollPane scroll = new JScrollPane(debug,
      JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
      JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    scroll.getViewport().setOpaque(setComponentOpaque(skin.DEBUG));
    scroll.setOpaque(setComponentOpaque(skin.DEBUG));
    scroll.setBounds(setComponentBounds(skin.DEBUG));
    scroll.setPreferredSize(setComponentDimension(skin.DEBUG));  
    panelCenter.add(scroll);
  }
  
  // Inicializa los iconos de minimizar y salir
  private void initIcons()  throws Exception
  {
    // Botn de salir
    final JLabel exit = new JLabel();  
    exit.setIcon(new ImageIcon(setComponentImage(skin.SALIR)));
    exit.setBounds(setComponentBounds(skin.SALIR));
    exit.addMouseListener(new MouseAdapter()
    {
      public void mouseEntered(MouseEvent e)
      {
        try{ 
          exit.setIcon(new ImageIcon(setComponentImageAlt(skin.SALIR)));
        }catch(Exception ee) {System.out.println("Error"+ee);}
      }

      public void mouseExited(MouseEvent e)
      {
        try{
          exit.setIcon(new ImageIcon(setComponentImage(skin.SALIR)));
        }catch(Exception ee) 
        {
          System.out.println("Error:"+ee);
        }
      }
      
      public void mouseClicked(MouseEvent e){agenda.saveAgenda();System.exit(0);}
    });
    getContentPane().add(exit);

    // Botn de minimizar
    final JLabel minimizar = new JLabel();  
    minimizar.setIcon(new ImageIcon(setComponentImage(skin.MINIMIZAR)));
    minimizar.setBounds(setComponentBounds(skin.MINIMIZAR));
    minimizar.addMouseListener(new MouseAdapter()
    {
      public void mouseEntered(MouseEvent e)
      {
        try{
          minimizar.setIcon(new ImageIcon(setComponentImageAlt(skin.MINIMIZAR)));
        }catch(Exception ee)
        {
          System.out.println("Error:"+ee);
        }
      }

      public void mouseExited(MouseEvent e)
      {
        try{
          minimizar.setIcon(new ImageIcon(setComponentImage(skin.MINIMIZAR)));
        }catch(Exception ee)
        {
          System.out.println("Error:"+ee);
        }
      }
      
      public void mouseClicked(MouseEvent e){setState(Frame.ICONIFIED);}
    });
    getContentPane().add(minimizar);
    
  }

  // Inicializamos al panel principal
  private void initPanelCenter() throws Exception
  {
    // Creamos el panel que va a contener todo;
    panelCenter = new JPanel()
    {
     public void paintComponent(Graphics g)
       {
          super.paintChildren( g );
          try{
            g.drawImage(setComponentImage(skin.PANELCENTER),
                                      setComponentBounds(skin.PANELCENTER).x,
                                      setComponentBounds(skin.PANELCENTER).y,
                                      setComponentBounds(skin.PANELCENTER).width,
                                      setComponentBounds(skin.PANELCENTER).height,null);
          }catch (Exception ee)
          {
            System.out.println("Error:"+ee);
          }
       }
    };        
    panelCenter.setLayout(null);
    panelCenter.setOpaque(setComponentOpaque(skin.PANELCENTER));
    panelCenter.setBounds(setComponentBounds(skin.PANELCENTER));    
  }
  
  private void initMainFrame() throws Exception
  {
    // Establecemos las propiedades del frame principal
    setUndecorated(true);
    getContentPane().setLayout(null);
    getContentPane().setBackground(setComponentBGColor(skin.FRAME));
    setSize(setComponentDimension(skin.FRAME));
    setTitle("Chang SMS");
  }
  
  private void initMenus() throws Exception
  {
    // Creamos la barra de menus con los mens correspondientes
    menuBar = new JMenuBar()    ;
    /*
    {
      public void paintComponent(Graphics g)
       {
          super.paintChildren( g );
          g.drawImage(setComponentImage(skin.MENU),
                                    setComponentBounds(skin.MENU).x,
                                    setComponentBounds(skin.MENU).y,
                                    setComponentBounds(skin.MENU).width,
                                    setComponentBounds(skin.MENU).height,null);
       }    
    };*/
    
    menuBar.setBorder(setComponentBorder(skin.MENU));
    menuBar.setOpaque(setComponentOpaque(skin.MENU));
    menuBar.setBackground(setComponentBGColor(skin.MENU));
    setJMenuBar(menuBar);
    menuFile.setText(idioma.getTexto("OPTIONS"));
    menuFile.setBackground(setComponentBGColor(skin.MENU));
    menuFile.setForeground(setComponentColor(skin.MENU));
    menuFile.setOpaque(setComponentOpaque(skin.MENU));
    menuFile.setFont(setComponentFont(skin.MENU));
    menuFileExit.setText(idioma.getTexto("EXIT"));
    menuFileExit.setOpaque(setComponentOpaque(skin.MENU));
    menuFileExit.setBackground(setComponentBGColor(skin.MENU));    
    menuFileExit.setForeground(setComponentColor(skin.MENU));
    menuFileExit.setFont(setComponentFont(skin.MENU));
    menuFileExit.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent ae)
      {fileExit_ActionPerformed(ae);}
    });
    menuHelp.setText(idioma.getTexto("HELP"));
    menuHelp.setBackground(setComponentBGColor(skin.MENU));    
    menuHelp.setOpaque(setComponentOpaque(skin.MENU));
    menuHelp.setForeground(setComponentColor(skin.MENU));
    menuHelp.setFont(setComponentFont(skin.MENU));
    menuHelpAbout.setText(idioma.getTexto("ABOUT"));
    menuHelpAbout.setOpaque(setComponentOpaque(skin.MENU));
    menuHelpAbout.setBackground(setComponentBGColor(skin.MENU));        
    menuHelpAbout.setForeground(setComponentColor(skin.MENU));
    menuHelpAbout.setFont(setComponentFont(skin.MENU));    
    menuHelpAbout.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent ae)
      {helpAbout_ActionPerformed(ae);}
    });
    menuServer.setText(idioma.getTexto("SERVERS"));
    menuServer.setOpaque(setComponentOpaque(skin.MENU));
    menuServer.setBackground(setComponentBGColor(skin.MENU));    
    menuServer.setForeground(setComponentColor(skin.MENU));
    menuServer.setFont(setComponentFont(skin.MENU));

    menuIdiomas.setText(idioma.getTexto("IDIOMAS"));
    menuIdiomas.setOpaque(setComponentOpaque(skin.MENU));
    menuIdiomas.setBackground(setComponentBGColor(skin.MENU));    
    menuIdiomas.setForeground(setComponentColor(skin.MENU));
    menuIdiomas.setFont(setComponentFont(skin.MENU));
    initMenuIdiomas();
    
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar.add(menuFile);
    menuBar.add(menuIdiomas);
    menuBar.add(menuServer);
    menuBar.add(menuHelp);    
  }

  private void initMenuIdiomas() throws Exception
  {
      idiomas = idioma.getIdiomas();
      Iterator iterar = idiomas.iterator();
      while (iterar.hasNext())
      {
        final String[] aux = (String[])iterar.next();
        JMenuItem menu = new JMenuItem();
        menu.setText(idioma.getTexto(aux[0]));
        menu.setOpaque(setComponentOpaque(skin.MENU));
        menu.setBackground(setComponentBGColor(skin.MENU));        
        menu.setForeground(setComponentColor(skin.MENU));
        menu.setFont(setComponentFont(skin.MENU));
        menu.addActionListener(new ActionListener()
        {
          public void actionPerformed(ActionEvent ae) 
          {
            try{
              idioma.setCountry(aux[2]);
              idioma.setLanguage(aux[1]);
              idioma.updateInit();
            }catch(Exception e){System.out.println("Error");}
          }
        });
        menuIdiomas.add(menu);
      }
      

  }

  // Accin para cerrar la ventana del frame
  void fileExit_ActionPerformed(ActionEvent e)
  {
    agenda.saveAgenda();
    System.exit(0);
  }

  // Accin para lanzar la pantalla de help
  void helpAbout_ActionPerformed(ActionEvent e)
  {
    try{
      JOptionPane.showMessageDialog(this, new linuxSMS_AboutBoxPanel1(), idioma.getTexto("ABOUT"), JOptionPane.PLAIN_MESSAGE);
    }catch(Exception er) {System.out.println("Error"+er);}
  }

  // Panel con el contenido relacionado con SMS
  private void panelSMS() throws Exception
  {
    // Creamos el botn para enviar el mensaje
    JButton enviar = new JButton(idioma.getTexto("SEND"));
    enviar.setFocusPainted(false);
    enviar.setOpaque(setComponentOpaque(skin.SEND));
    enviar.setBounds(setComponentBounds(skin.SEND));
    enviar.setBorder(setComponentBorder(skin.SEND));
    enviar.setPreferredSize(setComponentDimension(skin.SEND));    
    enviar.setFont(setComponentFont(skin.SEND));
    enviar.setForeground(setComponentColor(skin.SEND));    
    enviar.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent ae)
      {
        try{
          enviarSMS();
        }catch(Exception ee)
        {
          System.out.println("Error:"+ee);
        }
      }
    });

    // Creamos el textfield para el nmero receptor del mensaje
    numerotoSend.setOpaque(setComponentOpaque(skin.NUMBER));
    numerotoSend.setForeground(setComponentColor(skin.NUMBER));    
    numerotoSend.setFont(setComponentFont(skin.NUMBER));
    numerotoSend.setBounds(setComponentBounds(skin.NUMBER));
    numerotoSend.setBorder(setComponentBorder(skin.NUMBER));
    numerotoSend.setPreferredSize(setComponentDimension(skin.NUMBER));

    // Montamos donde ir el nombre del servidor
    servidor.setOpaque(setComponentOpaque(skin.SERVER));    
    servidor.setForeground(setComponentColor(skin.SERVER));
    servidor.setBounds(setComponentBounds(skin.SERVER));  
    servidor.setPreferredSize(setComponentDimension(skin.SERVER));    
    servidor.setFont(setComponentFont(skin.SERVER));

    // Montamos el jtextfield con el nmero mximo de caracteres
    maxChars.setEditable(false);
    maxChars.setOpaque(setComponentOpaque(skin.MAXCHARS));
    maxChars.setForeground(setComponentColor(skin.MAXCHARS));    
    maxChars.setFont(setComponentFont(skin.MAXCHARS));
    maxChars.setBounds(setComponentBounds(skin.MAXCHARS));
    maxChars.setBorder(setComponentBorder(skin.MAXCHARS));
    maxChars.setPreferredSize(setComponentDimension(skin.MAXCHARS));
    
    // Aadimos los componentes al panel central
    panelCenter.add(servidor);        
    panelCenter.add(numerotoSend);
    panelCenter.add(enviar);
    panelCenter.add(maxChars);
    panelCenter.add(panelSMS2());
  }


  private Component panelSMS2() throws Exception
  {
    mensaje.setForeground(setComponentColor(skin.SMS));
    mensaje.setBounds(setComponentBounds(skin.SMS));
    mensaje.setOpaque(setComponentOpaque(skin.SMS));
    mensaje.setCaretPosition(0);
    mensaje.setMargin(new Insets(5,5,5,5));    
    mensaje.setPreferredSize(setComponentDimension(skin.SMS));
    mensaje.setAutoscrolls(true);    
    
    JScrollPane scroll = new JScrollPane(mensaje,
      JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
      JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    scroll.getViewport().setOpaque(setComponentOpaque(skin.SMS));
    scroll.setOpaque(setComponentOpaque(skin.SMS));
    scroll.setBounds(setComponentBounds(skin.SMS));
    scroll.setPreferredSize(setComponentDimension(skin.SMS));
    return scroll;
  }

  // Accin llamada cuando enviamos el sms
  private void enviarSMS() throws Exception
  {
    sendSMS sender = new sendSMS(numerotoSend.getText(),servidor.getText(),mensaje.getText());
    String[] aux = sender.sendMessage();
    LimitedStyledDocument lsd_aux = new LimitedStyledDocument(1000);
    String newline = "\n";
    SimpleAttributeSet[] attrs = initAttributes(aux.length);
    try {
        for (int i = 0; i < aux.length; i ++) {
            lsd_aux.insertString(lsd_aux.getLength(), aux[i] + newline,
                    attrs[i]);
        }
    } catch (BadLocationException ble) {
        System.err.println("Couldn't insert initial text.");
    }
    debug.setStyledDocument(lsd_aux); 
  }

  protected SimpleAttributeSet[] initAttributes(int length) throws Exception {
    //Hard-code some attributes.
    SimpleAttributeSet[] attrs = new SimpleAttributeSet[length];

    attrs[0] = new SimpleAttributeSet();
    Font fuente = setComponentFont(skin.DEBUG);
    StyleConstants.setFontFamily(attrs[0], fuente.getFamily());
    StyleConstants.setFontSize(attrs[0], fuente.getSize());
    StyleConstants.setForeground(attrs[0], setComponentColor(skin.DEBUG));

    attrs[1] = new SimpleAttributeSet(attrs[0]);
    StyleConstants.setFontFamily(attrs[0], fuente.getFamily());
    StyleConstants.setFontSize(attrs[0], fuente.getSize());
    StyleConstants.setForeground(attrs[0], Color.RED);

    return attrs;
  }


  // Panel que contiene los contactos de la agenda
  private void panelAgendaContactos()  throws Exception
  {
    contacto.setBounds(setComponentBounds(skin.CONTACTO));
    contacto.setPreferredSize(setComponentDimension(skin.CONTACTO));
    contacto.setOpaque(setComponentOpaque(skin.CONTACTO));
    contacto.setFont(setComponentFont(skin.CONTACTO));
    contacto.setForeground(setComponentColor(skin.CONTACTO));

    prefijo.setBounds(setComponentBounds(skin.PREFIX));
    prefijo.setPreferredSize(setComponentDimension(skin.PREFIX));
    prefijo.setOpaque(setComponentOpaque(skin.PREFIX));
    prefijo.setFont(setComponentFont(skin.PREFIX));
    prefijo.setForeground(setComponentColor(skin.PREFIX));
    
    numero.setBounds(setComponentBounds(skin.NUMERO));
    numero.setPreferredSize(setComponentDimension(skin.NUMERO));
    numero.setOpaque(setComponentOpaque(skin.NUMERO));
    numero.setFont(setComponentFont(skin.NUMERO));
    numero.setForeground(setComponentColor(skin.NUMERO));
    
    panelCenter.add(contacto);
    panelCenter.add(numero);
    panelCenter.add(prefijo);
  }

  // Panel con las acciones de la agenda
  private void panelAgendaAcciones() throws Exception
  {
    JButton crearContacto = new JButton(idioma.getTexto("INSERT"));
    crearContacto.setFocusPainted(false);
    crearContacto.setFont(setComponentFont(skin.BADD));    
    crearContacto.setOpaque(setComponentOpaque(skin.BADD));
    crearContacto.setBounds(setComponentBounds(skin.BADD));
    crearContacto.setPreferredSize(setComponentDimension(skin.BADD));
    crearContacto.setForeground(setComponentColor(skin.BADD));

    JButton modificarContacto = new JButton(idioma.getTexto("MODIFY"));
    modificarContacto.setFocusPainted(false);
    modificarContacto.setFont(setComponentFont(skin.BMOD));    
    modificarContacto.setOpaque(setComponentOpaque(skin.BMOD));
    modificarContacto.setBounds(setComponentBounds(skin.BMOD));
    modificarContacto.setPreferredSize(setComponentDimension(skin.BMOD));
    modificarContacto.setForeground(setComponentColor(skin.BMOD));

    JButton eliminarContacto = new JButton(idioma.getTexto("DELETE"));
    eliminarContacto.setFocusPainted(false);
    eliminarContacto.setFont(setComponentFont(skin.BDEL));    
    eliminarContacto.setOpaque(setComponentOpaque(skin.BDEL));
    eliminarContacto.setBounds(setComponentBounds(skin.BDEL));
    eliminarContacto.setPreferredSize(setComponentDimension(skin.BDEL));
    eliminarContacto.setForeground(setComponentColor(skin.BDEL));
    
    panelCenter.add(crearContacto);
    panelCenter.add(modificarContacto);
    panelCenter.add(eliminarContacto);    

    crearContacto.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent ae)
      {crearContacto();}
    });

    eliminarContacto.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent ae)
      {eliminarContacto();}
    });

    modificarContacto.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent ae)
      {modificarContacto();}
    });
  }

  private void crearContacto()
  {
    String[] aux = new String[3];
    if (contacto.getText()!=null && numero.getText()!=null)
    {
      aux[0] = contacto.getText();
      aux[2] = numero.getText();  
      if (prefijo.getText()==null || prefijo.getText().equals(""))
        aux[1] = "34";
      else
        aux[1] = prefijo.getText();
      modelo.addValue(aux);
      agenda.addContacto(aux);
    }
  }

  private void eliminarContacto()
  {
    String[] aux = new String[3];
    if (contacto.getText()!=null && numero.getText()!=null)
    {
      aux[0] = contacto.getText();
      aux[2] = numero.getText();
      if (prefijo.getText()==null || prefijo.getText().equals(""))
        aux[1] = "34";
      else
        aux[1] = prefijo.getText();     
      modelo.deleteRow(aux);
      agenda.removeContacto(aux);
    }
  }

  private void modificarContacto()
  {
    modelo.updateRow(filaAgenda,contacto.getText(),numero.getText(),prefijo.getText());
    String[] aux = new String[3];
    if (contacto.getText()!=null && numero.getText()!=null)
    {
      aux[0] = contacto.getText();
      aux[2] = numero.getText();
      if (prefijo.getText()==null || prefijo.getText().equals(""))
        aux[1] = "34";
      else
        aux[1] = prefijo.getText();     
      agenda.updateContacto(aux);
    }

  }

  private void panelAgenda() throws Exception
  {  
    JScrollPane scroll = new JScrollPane(table);
    scroll.setBounds(setComponentBounds(skin.AGENDA));
    scroll.setPreferredSize(setComponentDimension(skin.AGENDA));    
    scroll.getViewport().setOpaque(setComponentOpaque(skin.AGENDA));
    scroll.setOpaque(setComponentOpaque(skin.AGENDA));
    table.setOpaque(setComponentOpaque(skin.AGENDA));
    //table.setPreferredScrollableViewportSize(new Dimension(130, 160));
    table.setBounds(setComponentBounds(skin.AGENDA));
    JTextField celda = new JTextField(){
      {
        try{
          setOpaque(setComponentOpaque(skin.AGENDA));
        }catch(Exception ee)
        {
          System.out.println("Error:"+ee);
        }
      }
    };
    celda.setOpaque(setComponentOpaque(skin.AGENDA));
    table.setDefaultEditor(Object.class, new DefaultCellEditor(celda));
    table.setPreferredSize(setComponentDimension(skin.AGENDA));
    table.setFont(setComponentFont(skin.AGENDA));
    table.setForeground(setComponentColor(skin.AGENDA));
    table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    table.setAutoCreateColumnsFromModel(true);

    table.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        if (!e.isTemporary()) {
          if (table.isEditing()) {
             cmp = table.getEditorComponent();
             columna = table.getEditingColumn();
             fila = table.getEditingRow();
             cmp.addFocusListener( new FocusAdapter() {
                  public void focusLost(FocusEvent e) {
                      if (!e.isTemporary() && (((Component) e.getSource()).getParent() instanceof JTable)) {
                         table.removeEditor();
                      }
                      String num = "";
                      String nom = ""; 
                      String pre = "";
                      String texto = ((JTextField)cmp).getText();             
                      switch (columna)
                      {
                        case 0:
                                nom = texto;
                                num = (String)modelo.getValueAt(fila,2);
                                pre = (String)modelo.getValueAt(fila,1);
                                break;
                        case 1:
                                nom = (String)modelo.getValueAt(fila,0);
                                num = (String)modelo.getValueAt(fila,2);
                                pre = texto;
                                break;
                        case 2:
                                nom = (String)modelo.getValueAt(fila,0);
                                num = texto;
                                pre = (String)modelo.getValueAt(fila,1);
                                break;                                
                        default: break;
                      }
                      modelo.updateRow(fila,nom,num,pre);
                  } 
             }); 
          } 
        } 
      } 
    }); 

    ListSelectionModel rowSM = table.getSelectionModel();
    rowSM.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting()) return;  
        ListSelectionModel lsm = (ListSelectionModel)e.getSource();
        if (!lsm.isSelectionEmpty()) 
        {
          filaAgenda = lsm.getMinSelectionIndex();
          String[] aux = (String[])modelo.getValueAt(filaAgenda);
          if (aux!= null)
          {
            contacto.setText(aux[0]);
            numero.setText(aux[2]);
            prefijo.setText(aux[1]);
            numerotoSend.setText(aux[1]+" "+aux[2] +"("+aux[0]+")");
          }
        }
      }});
    panelCenter.add(scroll);      
  }
  
  private Border setComponentBorder(String component) throws Exception
  {
    boolean sinBorder = ((Boolean)(skin.getComponentValue(component,skin.BORDER))).booleanValue();
    if (sinBorder)
      return BorderFactory.createEmptyBorder();
    else
      return BorderFactory.createEtchedBorder();
  }
  
  private Font setComponentFont(String component) throws Exception
  {
    return (Font)skin.getComponentValue(component,skin.FONT);
  }

  private Image setComponentImage(String component) throws Exception
  {
    return (Image)skin.getComponentValue(component,skin.IMAGE);
  }

  private Image setComponentImageAlt(String component) throws Exception
  {
    return (Image)skin.getComponentValue(component,skin.IMGALT);
  }
  private Color setComponentColor(String component) throws Exception
  {
    return (Color)skin.getComponentValue(component,skin.FONTCOLOR);
  }

  private Color setComponentBGColor(String component) throws Exception
  {
    return (Color)skin.getComponentValue(component,skin.FRAMEBGCOLOR);
  }
  
  private boolean setComponentOpaque(String component) throws Exception
  {
    return ((Boolean)(skin.getComponentValue(component,skin.OPAQUE))).booleanValue();
  }
  
  private Rectangle setComponentBounds(String component) throws Exception
  {
    Insets insets = this.getContentPane().getInsets();
    int x = insets.left + Integer.parseInt(skin.getComponentValue(component,skin.X).toString());
    int y = insets.top+Integer.parseInt(skin.getComponentValue(component,skin.Y).toString());
    int w = Integer.parseInt(skin.getComponentValue(component,skin.W).toString());
    int h = Integer.parseInt(skin.getComponentValue(component,skin.H).toString());
    return new Rectangle(x,y,w,h);    
  }

  private Dimension setComponentDimension(String component) throws Exception
  {
    int w = Integer.parseInt(skin.getComponentValue(component,skin.W).toString());
    int h = Integer.parseInt(skin.getComponentValue(component,skin.H).toString());
    return new Dimension(w,h);
  }  
}