package com.chang.sms;

import java.awt.Color;
import java.awt.Font;
import java.awt.Image;

import java.io.*;

import java.util.Properties;
import java.util.StringTokenizer;

import javax.swing.*;
import java.net.*;

public class skinSMS 
{
  private Properties p = null;
  final static int X=1,Y=2,W=3,H=4,OPAQUE=5,BORDER=6,FONT=7;
  final static int FONTCOLOR = 18,IMAGE=13,FRAMEBGCOLOR=19,IMGALT=17;
  private final static int FONTSTYLE=8,FONTHEIGHT=9,R=10,G=11,B=12,RF=14,GF=15,BF=16;
  static final String SERVER      = "server";
  static final String NUMBER      = "numberSend";  
  static final String SEND        = "buttonSend";  
  static final String MENU        = "menuSkin";
  static final String PANELCENTER = "skin";
  static final String FRAME       = "frame";
  static final String SMS         = "text"; 
  static final String CONTACTO    = "contacto"; 
  static final String NUMERO      = "numero"; 
  static final String BADD        = "badd"; 
  static final String BMOD        = "bmod"; 
  static final String BDEL        = "bdel"; 
  static final String AGENDA      = "agenda"; 
  static final String MINIMIZAR   = "minimizar"; 
  static final String SALIR       = "salir"; 
  static final String MAXCHARS    = "maxChars"; 
  static final String PREFIX      = "prefix"; 
  static final String DEBUG       = "debug";

  static private String home = System.getProperty("user.home", "not specified");
  
  public skinSMS() throws Exception
  {
    p = new Properties();
    File file = new File(home,".linuxsms");
    file = new File(file,"skin");
    file = new File(file,"skin.properties");
    p.load(new FileInputStream(file));
//    p.load(this.getClass().getResourceAsStream("skin/skin.properties"));
  }

  private String getToken(String word,int position)
  {
    String salida = "";
    StringTokenizer st = new StringTokenizer(word," ");
    for (int i = 0;i<position;i++)
      salida = st.nextToken();
    return salida;
  }

  public Object getComponentValue(String component,int value) throws Exception
  {
    Object salida = null; 
    switch (value)
    {
      case X: return new Integer(getToken(p.getProperty(component),X));
      case Y: return new Integer(getToken(p.getProperty(component),Y));
      case W: return new Integer(getToken(p.getProperty(component),W));
      case H: return new Integer(getToken(p.getProperty(component),H));
      case OPAQUE: return new Boolean(getToken(p.getProperty(component),OPAQUE));
      case BORDER:
          if (getToken(p.getProperty(component),BORDER).equals("none"))
            return  new Boolean(true);
          else 
            return new Boolean(false);
      case FONT: 
        String font = getToken(p.getProperty(component),FONT);
        String style = getToken(p.getProperty(component),FONTSTYLE);
        int estilo = Font.PLAIN;
        if (style!=null)
          if (style.equals("BOLD"))
            estilo =  Font.BOLD;
          else if (style.equals("PLAIN"))
            estilo = Font.PLAIN;
        else estilo = Font.PLAIN;
        int altura = Integer.parseInt(getToken(p.getProperty(component),FONTHEIGHT));
        return new Font(font,estilo,altura);
      case FONTCOLOR:
        return new Color(
          Integer.parseInt(getToken(p.getProperty(component),R)),
          Integer.parseInt(getToken(p.getProperty(component),G)),
          Integer.parseInt(getToken(p.getProperty(component),B)));
      case IMAGE:
          ImageIcon boton = createImageIcon("images/"+getToken(p.getProperty(component),IMAGE));
          Image image = boton.getImage();
          return image;
      case IMGALT:
          ImageIcon boton2 = createImageIcon("images/"+getToken(p.getProperty(component),IMGALT));
          Image image2 = boton2.getImage();
          return image2;          
      case FRAMEBGCOLOR:
        return new Color(
          Integer.parseInt(getToken(p.getProperty(component),RF)),
          Integer.parseInt(getToken(p.getProperty(component),GF)),
          Integer.parseInt(getToken(p.getProperty(component),BF)));          
      default: return null;
    }
  }

  protected static ImageIcon createImageIcon(String path) throws Exception{
    File file = new File(home,".linuxsms");
    file = new File(file,path);

    URL imgURL = new URL("file","",file.getAbsolutePath());
    //changSMS.class.getResource(path);
    if (imgURL != null)
        return new ImageIcon(imgURL);
    else {
        System.err.println("Couldn't find file: " + path);
        return null;
    }
  }  
}